# @author Charles Sprayberry
# @copyright Copyright (c) 2013 Charles Sprayberry
# @license OSI MIT

Dir[File.dirname(__FILE__) + "/**/*.rb"].each {|f| require f}

# The module that exposes the primary API that allows any object to easily handle events being added and triggered on it
#
# Please note that we are using prefixes on instance variables ON PURPOSE; please do not remove the instance prefixes
module SprayVent

  # Sets up the event mediator that will be used to manage the instances events
  #
  # @return void
  def event_init
    @eventable_events = Mediator.new(self)
  end

  # Returns the event mediator attached to the instance that handles the adding and triggering of events
  #
  # @return Eventable::Mediator
  def events
    event_init if @eventable_events.nil?
    @eventable_events
  end

end
